| LPCOpen Platform v1.03 LPCOpen Platform for NXP LPC Microcontrollers

- Main Page
- Modules
- Data Structures
- Files
- Related Pages

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Enumerations
Read/Write of Multi-Byte Streams
Endpoint Data Reading and Writing

## Detailed Description

Endpoint data stream transmission and reception management.

Functions, macros, variables, enums and types related to data reading and writing of data streams from and to endpoints.

## Enumerations
enum | Endpoint_Stream_RW_ErrorCodes_t { ENDPOINT_RWSTREAM_NoError = 0, ENDPOINT_RWSTREAM_EndpointStalled = 1, ENDPOINT_RWSTREAM_DeviceDisconnected = 2, ENDPOINT_RWSTREAM_BusSuspended = 3, ENDPOINT_RWSTREAM_Timeout = 4, ENDPOINT_RWSTREAM_IncompleteTransfer = 5 }
enum | Endpoint_ControlStream_RW_ErrorCodes_t { ENDPOINT_RWCSTREAM_NoError = 0, ENDPOINT_RWCSTREAM_HostAborted = 1, ENDPOINT_RWCSTREAM_DeviceDisconnected = 2, ENDPOINT_RWCSTREAM_BusSuspended = 3 }

## Enumeration Type Documentation

enum Endpoint_ControlStream_RW_ErrorCodes_t

Enum for the possible error return codes of the `Endpoint_*_Control_Stream_*` functions.

Enumerator:

  ENDPOINT_RWCSTREAM_NoError | Command completed successfully, no error.
  ENDPOINT_RWCSTREAM_HostAborted | The aborted the transfer prematurely.
  ENDPOINT_RWCSTREAM_DeviceDisconnected | Device was disconnected from the host during the transfer.
  ENDPOINT_RWCSTREAM_BusSuspended | The USB bus has been suspended by the host and no USB endpoint traffic can occur until the bus has resumed.

Definition at line 88 of file EndpointStream.h.

enum Endpoint_Stream_RW_ErrorCodes_t

Enum for the possible error return codes of the `Endpoint_*_Stream_*` functions.

Enumerator:

  ENDPOINT_RWSTREAM_NoError | Command completed successfully, no error.
  ENDPOINT_RWSTREAM_EndpointStalled | The endpoint was stalled during the stream transfer by the host or device.
  ENDPOINT_RWSTREAM_DeviceDisconnected | Device was disconnected from the host during the transfer.
  ENDPOINT_RWSTREAM_BusSuspended | The USB bus has been suspended by the host and no USB endpoint traffic can occur until the bus has resumed.
  ENDPOINT_RWSTREAM_Timeout | The host failed to accept or send the next packet within the software timeout period set by the USB_STREAM_TIMEOUT_MS macro.
  ENDPOINT_RWSTREAM_IncompleteTransfer | Indicates that the endpoint bank became full or empty before the complete contents of the current stream could be transferred. The endpoint stream function should be called again to process the next chunk of data in the transfer.

Definition at line 63 of file EndpointStream.h.

## Function Documentation

uint8_t Endpoint_Discard_Stream | ( | uint8_t | corenum,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads and discards the given number of bytes from the currently selected endpoint's bank, discarding fully read packets from the host as needed. The last packet is not automatically discarded once the remaining bytes has been read; the user is responsible for manually discarding the last packet from the host via the Endpoint_ClearOUT() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the endpoint bank becomes empty while there is still data to process (and after the current packet has been acknowledged) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of ENDPOINT_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t ErrorCode;
if ((ErrorCode = Endpoint_Discard_Stream(512, NULL)) != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Endpoint_Discard_Stream(512, &BytesProcessed)) == ENDPOINT_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  corenum | ID Number of USB Core to be processed.
  Length | Number of bytes to discard via the currently selected endpoint.
  BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once.
  Length | : Number of bytes to discard via the currently selected endpoint
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, NULL if the entire stream should be read at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

Definition at line 40 of file EndpointStream.c.

uint8_t Endpoint_Null_Stream | ( | uint8_t | corenum,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes a given number of zeroed bytes to the currently selected endpoint's bank, sending full packets to the host as needed. The last packet is not automatically sent once the remaining bytes have been written; the user is responsible for manually sending the last packet to the host via the Endpoint_ClearIN() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the endpoint bank becomes full while there is still data to process (and after the current packet transmission has been initiated) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of ENDPOINT_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t ErrorCode;
if ((ErrorCode = Endpoint_Null_Stream(512, NULL)) != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Endpoint_Null_Stream(512, &BytesProcessed)) == ENDPOINT_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  corenum | ID Number of USB Core to be processed.
  Length | Number of zero bytes to send via the currently selected endpoint.
  BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once.
  Length | : Number of zero bytes to send via the currently selected endpoint
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, NULL if the entire stream should be read at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

Definition at line 50 of file EndpointStream.c.

uint8_t Endpoint_Read_Control_EStream_BE | ( | void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Endpoint Read Control EEPROM Stream Big Endian.

Note
  This function automatically clears the control transfer's status stage. Do not manually attempt to clear the status stage when using this routine in a control transaction.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  Buffer | : Pointer to the destination data buffer to write to
  Length | : Number of bytes to send via the currently selected endpoint

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

uint8_t Endpoint_Read_Control_EStream_LE | ( | void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Endpoint Read Control EEPROM Stream Little Endian.

Note
  This function automatically clears the control transfer's status stage. Do not manually attempt to clear the status stage when using this routine in a control transaction.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  Buffer | : Pointer to the destination data buffer to write to
  Length | : Number of bytes to send via the currently selected endpoint

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

uint8_t Endpoint_Read_Control_Stream_BE | ( | void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Reads the given number of bytes from the CONTROL endpoint from the given buffer in big endian, discarding fully read packets from the host as needed. The device IN acknowledgement is not automatically sent after success or failure states; the user is responsible for manually sending the setup IN to finalize the transfer via the Endpoint_ClearIN() macro.

Note
  This function automatically clears the control transfer's status stage. Do not manually attempt to clear the status stage when using this routine in a control transaction.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  Buffer | : Pointer to the destination data buffer to write to
  Length | : Number of bytes to send via the currently selected endpoint

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

Definition at line 153 of file EndpointStream.c.

uint8_t Endpoint_Read_Control_Stream_LE | ( | uint8_t | corenum,
|  | void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Reads the given number of bytes from the CONTROL endpoint from the given buffer in little endian, discarding fully read packets from the host as needed. The device IN acknowledgement is not automatically sent after success or failure states; the user is responsible for manually sending the setup IN to finalize the transfer via the Endpoint_ClearIN() macro.

Note
  This function automatically clears the control transfer's status stage. Do not manually attempt to clear the status stage when using this routine in a control transaction.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  corenum | ID Number of USB Core to be processed.
  Buffer | : Pointer to the destination data buffer to write to
  Length | : Number of bytes to send via the currently selected endpoint

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

Definition at line 144 of file EndpointStream.c.

uint8_t Endpoint_Read_EStream_BE | ( | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Endpoint Read EEPROM Stream Big Endian.

Parameters

  Buffer | : Pointer to the destination data buffer to write to, located in EEPROM memory space
  Length | : Number of bytes to send via the currently selected endpoint
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

uint8_t Endpoint_Read_EStream_LE | ( | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Endpoint Read EEPROM Stream Little Endian.

Parameters

  Buffer | : Pointer to the destination data buffer to write to, located in EEPROM memory space
  Length | : Number of bytes to send via the currently selected endpoint
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

uint8_t Endpoint_Read_Stream_BE | ( | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads the given number of bytes from the endpoint from the given buffer in big endian, discarding fully read packets from the host as needed. The last packet is not automatically discarded once the remaining bytes has been read; the user is responsible for manually discarding the last packet from the host via the Endpoint_ClearOUT() macro.

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  Buffer | : Pointer to the destination data buffer to write to
  Length | : Number of bytes to send via the currently selected endpoint
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

Definition at line 118 of file EndpointStream.c.

uint8_t Endpoint_Read_Stream_LE | ( | uint8_t | corenum,
|  | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads the given number of bytes from the endpoint from the given buffer in little endian, discarding fully read packets from the host as needed. The last packet is not automatically discarded once the remaining bytes has been read; the user is responsible for manually discarding the last packet from the host via the Endpoint_ClearOUT() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the endpoint bank becomes empty while there is still data to process (and after the current packet has been acknowledged) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of ENDPOINT_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
if ((ErrorCode = Endpoint_Read_Stream_LE(DataStream, sizeof(DataStream),
NULL)) != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Endpoint_Read_Stream_LE(DataStream, sizeof(DataStream),
&BytesProcessed)) == ENDPOINT_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  | corenum | ID Number of USB Core to be processed.
  [out] | Buffer | Pointer to the destination data buffer to write to.
  | Length | Number of bytes to send via the currently selected endpoint.
  | BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once.
  | Buffer | : Pointer to the destination data buffer to write to
  | Length | : Number of bytes to send via the currently selected endpoint
  | BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, NULL if the entire stream should be written at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

Definition at line 92 of file EndpointStream.c.

uint8_t Endpoint_Write_Control_EStream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Endpoint Write Control EEPROM Stream Big Endian.

Note
  This function automatically clears the control transfer's status stage. Do not manually attempt to clear the status stage when using this routine in a control transaction.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

uint8_t Endpoint_Write_Control_EStream_LE | ( | const void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Endpoint Write Control EEPROM Stream Little Endian.

Note
  This function automatically clears the control transfer's status stage. Do not manually attempt to clear the status stage when using this routine in a control transaction.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

uint8_t Endpoint_Write_Control_PStream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Endpoint Write Control PROGMEM Stream Big Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

uint8_t Endpoint_Write_Control_PStream_LE | ( | const void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Endpoint Write Control PROGMEM Stream Little Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

uint8_t Endpoint_Write_Control_Stream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Writes the given number of bytes to the CONTROL type endpoint from the given buffer in big endian, sending full packets to the host as needed. The host OUT acknowledgement is not automatically cleared in both failure and success states; the user is responsible for manually clearing the setup OUT to finalize the transfer via the Endpoint_ClearOUT() macro.

Note
  This function automatically clears the control transfer's status stage. Do not manually attempt to clear the status stage when using this routine in a control transaction.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

Definition at line 138 of file EndpointStream.c.

uint8_t Endpoint_Write_Control_Stream_LE | ( | uint8_t | corenum,
|  | const void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Writes the given number of bytes to the CONTROL type endpoint from the given buffer in little endian, sending full packets to the host as needed. The host OUT acknowledgement is not automatically cleared in both failure and success states; the user is responsible for manually clearing the setup OUT to finalize the transfer via the Endpoint_ClearOUT() macro.

Note
  This function automatically clears the control transfer's status stage. Do not manually attempt to clear the status stage when using this routine in a control transaction.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  corenum | ID Number of USB Core to be processed.
  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum

Definition at line 127 of file EndpointStream.c.

uint8_t Endpoint_Write_EStream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Endpoint Write EEPROM Stream Big Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be written at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

uint8_t Endpoint_Write_EStream_LE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Endpoint Write EEPROM Stream Little Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be written at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

uint8_t Endpoint_Write_PStream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Endpoint Write PROGMEM Stream Big Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

uint8_t Endpoint_Write_PStream_LE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Endpoint Write PROGMEM Stream Little Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, NULL if the entire stream should be written at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

uint8_t Endpoint_Write_Stream_BE | ( | uint8_t | corenum,
|  | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes the given number of bytes to the endpoint from the given buffer in big endian, sending full packets to the host as needed. The last packet filled is not automatically sent; the user is responsible for manually sending the last written packet to the host via the Endpoint_ClearIN() macro.

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  corenum | ID Number of USB Core to be processed.
  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be written at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

Definition at line 80 of file EndpointStream.c.

uint8_t Endpoint_Write_Stream_LE | ( | uint8_t | corenum,
|  | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes the given number of bytes to the endpoint from the given buffer in little endian, sending full packets to the host as needed. The last packet filled is not automatically sent; the user is responsible for manually sending the last written packet to the host via the Endpoint_ClearIN() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the endpoint bank becomes full while there is still data to process (and after the current packet transmission has been initiated) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of ENDPOINT_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
if ((ErrorCode = Endpoint_Write_Stream_LE(DataStream, sizeof(DataStream),
NULL)) != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Endpoint_Write_Stream_LE(DataStream, sizeof(DataStream),
&BytesProcessed)) == ENDPOINT_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  corenum | ID Number of USB Core to be processed.
  Buffer | Pointer to the source data buffer to read from.
  Length | Number of bytes to read for the currently selected endpoint into the buffer.
  BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be written at once.
  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected endpoint into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes processed in the current transaction should be updated, NULL if the entire stream should be written at once

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum

Definition at line 64 of file EndpointStream.c.